Index: /WAeUP_SRP/trunk/profiles/uniben/vocabularies/pin_prefixes.xml
===================================================================
--- /WAeUP_SRP/trunk/profiles/uniben/vocabularies/pin_prefixes.xml	(revision 5009)
+++ /WAeUP_SRP/trunk/profiles/uniben/vocabularies/pin_prefixes.xml	(revision 5010)
@@ -40,5 +40,5 @@
   <item key="SSC" msgid="">Social Sciences</item>
   <item key="MGS" msgid="">Management Sciences</item>
-  <item key="BSC" msgid="">Computer Sciences</item>
+  <item key="BSC" msgid="">Bachelor in Computer Science</item>
   <item key="FRN" msgid="">Returning Foreign Students</item>
 
@@ -56,5 +56,5 @@
   <item key="SSCNEW" msgid="">Social Sciences (New Students)</item>
   <item key="MGSNEW" msgid="">Management Sciences (New Students)</item>
-  <item key="BSCNEW" msgid="">Computer Sciences (New Students)</item>
+  <item key="BSCNEW" msgid="">Bachelor in Computer Science (New Students)</item>
   <item key="FRNNEW" msgid="">Returning Foreign New Students</item>
   
@@ -66,55 +66,55 @@
   <item key="LLM" msgid="">Masters in Law</item>
   <item key="MPH" msgid="">Masters in Public Health</item>
-  <item key="BPA" msgid="">Bachelors in Public Adm</item>
-  <item key="BIA" msgid="">Bachelors in Accounting</item>
-  <item key="BSW" msgid="">Bachelors in Social Wks</item>
-  <item key="BFA" msgid="">Bachelors in Fine Arts</item>
-  <item key="BTA" msgid="">Bachelors in Theatre Arts</item>
-  <item key="BEL" msgid="">Bachelors in English and Literature</item>
-  <item key="BISD" msgid="">Bachelors in Int. Studies and Diplomacy</item>
-  <item key="BFR" msgid="">Bachelors in French</item>
-  <item key="BIH" msgid="">Bachelors in History</item>
-  <item key="BIL" msgid="">Bachelors in Linguistics</item>
-  <item key="BAE" msgid="">Bachelors in Agric Economics</item>
-  <item key="BAN" msgid="">Bachelors in Animal Science</item>
-  <item key="BAC" msgid="">Bachelors in Crop Science</item>
-  <item key="BIF" msgid="">Bachelors in Fisheries</item>
-  <item key="BFW" msgid="">Bachelors in Forestry and Wildlife</item>
-  <item key="BAS" msgid="">Bachelors in Soil Science</item>
-  <item key="BEMCH" msgid="">Bachelors in Mechanical Eng.</item>
-  <item key="BBF" msgid="">Bachelors in Banking and Finance</item>
-  <item key="BLG" msgid="">Bachelors in Local Govt Admin</item>
-  <item key="BLST" msgid="">Bachelors in science Lab Tech.</item>
-  <item key="BES" msgid="">Bachelors in Envr. Science</item>
-  <item key="BIP" msgid="">Bachelors in Physics</item>
-  <item key="BPH" msgid="">Bachelors in Philosophy</item>
-  <item key="BSCS" msgid="">Bachelors in Statistics with Comp</item>
-  <item key="BEEL" msgid="">Bachelors in Elect and Elect Eng</item>
-  <item key="BECV" msgid="">Bachelors in Civil Eng.</item>
-  <item key="BECE" msgid="">Bachelors in Chemical Eng.</item>
-  <item key="BEME" msgid="">Bachelors in Mechanical Eng.</item>
-  <item key="BEPE" msgid="">Bachelors in Petroleum Eng.</item>
-  <item key="BESTR" msgid="">Bachelors in Structural Eng.</item>
-  <item key="BPRE" msgid="">Bachelors in Production Eng.</item>
-  <item key="BECO" msgid="">Bachelors in Computer Eng.</item>
-  <item key="BADTSW" msgid="">Bachelors in Adult Education (Sandwich)</item>
-  <item key="BISCSW" msgid="">Bachelors in Integrated Sci. Education (Sandwich)</item>
-  <item key="BHEDSW" msgid="">Bachelors in Health Education (Sandwich)</item>
-  <item key="BSSTSW" msgid="">Bachelors in Social studies Education (Sandwich)</item>
-  <item key="BBEDSW" msgid="">Bachelors in Business Education (Sandwich)</item>
-  <item key="BHECSW" msgid="">Bachelors in Home Economics Education (Sandwich)</item>
-  <item key="BEMGTSW" msgid="">Bachelors in Educational Management (Sandwich)</item>
-  <item key="BENLSW" msgid="">Bachelors in English and Literature Education (Sandwich)</item>
-  <item key="BCSCSW" msgid="">Bachelors in Computer Science Education (Sandwich)</item>
-  <item key="BCHESW" msgid="">Bachelors in Chemistry Education (Sandwich)</item>
-  <item key="BAGRSW" msgid="">Bachelors in Agriculture (Sandwich)</item>
-  <item key="BBIOSW" msgid="">Bachelors in Biology Education (Sandwich)</item>
-  <item key="BITESW" msgid="">Bachelors in Industrial Tech. Education (Sandwich)</item>
-  <item key="BGEOSW" msgid="">Bachelors in Geography Education (Sandwich)</item>
-  <item key="BPOLSW" msgid="">Bachelors in Political Sci. Education (Sandwich)</item>
-  <item key="BHISSW" msgid="">Bachelors in History Education (Sandwich)</item>
-  <item key="BECOSW" msgid="">Bachelors in Economics Education (Sandwich)</item>
+  <item key="BPA" msgid="">Bachelor in Public Adm</item>
+  <item key="BIA" msgid="">Bachelor in Accounting</item>
+  <item key="BSW" msgid="">Bachelor in Social Wks</item>
+  <item key="BFA" msgid="">Bachelor in Fine Arts</item>
+  <item key="BTA" msgid="">Bachelor in Theatre Arts</item>
+  <item key="BEL" msgid="">Bachelor in English and Literature</item>
+  <item key="BISD" msgid="">Bachelor in Int. Studies and Diplomacy</item>
+  <item key="BFR" msgid="">Bachelor in French</item>
+  <item key="BIH" msgid="">Bachelor in History</item>
+  <item key="BIL" msgid="">Bachelor in Linguistics</item>
+  <item key="BAE" msgid="">Bachelor in Agric Economics</item>
+  <item key="BAN" msgid="">Bachelor in Animal Science</item>
+  <item key="BAC" msgid="">Bachelor in Crop Science</item>
+  <item key="BIF" msgid="">Bachelor in Fisheries</item>
+  <item key="BFW" msgid="">Bachelor in Forestry and Wildlife</item>
+  <item key="BAS" msgid="">Bachelor in Soil Science</item>
+  <item key="BEMCH" msgid="">Bachelor in Mechanical Eng.</item>
+  <item key="BBF" msgid="">Bachelor in Banking and Finance</item>
+  <item key="BLG" msgid="">Bachelor in Local Govt Admin</item>
+  <item key="BLST" msgid="">Bachelor in science Lab Tech.</item>
+  <item key="BES" msgid="">Bachelor in Envr. Science</item>
+  <item key="BIP" msgid="">Bachelor in Physics</item>
+  <item key="BPH" msgid="">Bachelor in Philosophy</item>
+  <item key="BSCS" msgid="">Bachelor in Statistics with Comp</item>
+  <item key="BEEL" msgid="">Bachelor in Elect and Elect Eng</item>
+  <item key="BECV" msgid="">Bachelor in Civil Eng.</item>
+  <item key="BECE" msgid="">Bachelor in Chemical Eng.</item>
+  <item key="BEME" msgid="">Bachelor in Mechanical Eng.</item>
+  <item key="BEPE" msgid="">Bachelor in Petroleum Eng.</item>
+  <item key="BESTR" msgid="">Bachelor in Structural Eng.</item>
+  <item key="BPRE" msgid="">Bachelor in Production Eng.</item>
+  <item key="BECO" msgid="">Bachelor in Computer Eng.</item>
+  <item key="BADTSW" msgid="">Bachelor in Adult Education (Sandwich)</item>
+  <item key="BISCSW" msgid="">Bachelor in Integrated Sci. Education (Sandwich)</item>
+  <item key="BHEDSW" msgid="">Bachelor in Health Education (Sandwich)</item>
+  <item key="BSSTSW" msgid="">Bachelor in Social studies Education (Sandwich)</item>
+  <item key="BBEDSW" msgid="">Bachelor in Business Education (Sandwich)</item>
+  <item key="BHECSW" msgid="">Bachelor in Home Economics Education (Sandwich)</item>
+  <item key="BEMGTSW" msgid="">Bachelor in Educational Management (Sandwich)</item>
+  <item key="BENLSW" msgid="">Bachelor in English and Literature Education (Sandwich)</item>
+  <item key="BCSCSW" msgid="">Bachelor in Computer Science Education (Sandwich)</item>
+  <item key="BCHESW" msgid="">Bachelor in Chemistry Education (Sandwich)</item>
+  <item key="BAGRSW" msgid="">Bachelor in Agriculture (Sandwich)</item>
+  <item key="BBIOSW" msgid="">Bachelor in Biology Education (Sandwich)</item>
+  <item key="BITESW" msgid="">Bachelor in Industrial Tech. Education (Sandwich)</item>
+  <item key="BGEOSW" msgid="">Bachelor in Geography Education (Sandwich)</item>
+  <item key="BPOLSW" msgid="">Bachelor in Political Sci. Education (Sandwich)</item>
+  <item key="BHISSW" msgid="">Bachelor in History Education (Sandwich)</item>
+  <item key="BECOSW" msgid="">Bachelor in Economics Education (Sandwich)</item>
   <item key="BMTHSW" msgid="">Bachelor in Maths Eduction (Sandwich)</item>
-  <item key="LLBPT" msgid="">Bachelors in Law</item>
+  <item key="LLBPT" msgid="">Bachelor in Law</item>
   <item key="ODPT" msgid="">Doctor of Optometry</item>
   <item key="PHARMD" msgid="">Doctor of Pharmacy</item>
@@ -125,55 +125,55 @@
   <item key="LLMNEW" msgid="">Masters in Law (New Students)</item>
   <item key="MPHNEW" msgid="">Masters in Public Health (New Students)</item>
-  <item key="BPANEW" msgid="">Bachelors in Public Adm (New Students)</item>
-  <item key="BIANEW" msgid="">Bachelors in Accounting (New Students)</item>
-  <item key="BSWNEW" msgid="">Bachelors in Social Wks (New Students)</item>
-  <item key="BFANEW" msgid="">Bachelors in Fine Arts (New Students)</item>
-  <item key="BTANEW" msgid="">Bachelors in Theatre Arts (New Students)</item>
-  <item key="BELNEW" msgid="">Bachelors in English and Literature (New Students)</item>
-  <item key="BISDNEW" msgid="">Bachelors in Int. Studies and Diplomacy (New Students)</item>
-  <item key="BFRNEW" msgid="">Bachelors in French (New Students)</item>
-  <item key="BIHNEW" msgid="">Bachelors in History (New Students)</item>
-  <item key="BILNEW" msgid="">Bachelors in Linguistics (New Students)</item>
-  <item key="BAENEW" msgid="">Bachelors in Agric Economics (New Students)</item>
-  <item key="BANNEW" msgid="">Bachelors in Animal Science (New Students)</item>
-  <item key="BACNEW" msgid="">Bachelors in Crop Science (New Students)</item>
-  <item key="BIFNEW" msgid="">Bachelors in Fisheries (New Students)</item>
-  <item key="BFWNEW" msgid="">Bachelors in Forestry and Wildlife (New Students)</item>
-  <item key="BASNEW" msgid="">Bachelors in Soil Science (New Students)</item>
-  <item key="BEMCHNEW" msgid="">Bachelors in Mechanical Eng. (New Students)</item>
-  <item key="BBFNEW" msgid="">Bachelors in Banking and Finance (New Students)</item>
-  <item key="BLGNEW" msgid="">Bachelors in Local Govt Admin (New Students)</item>
-  <item key="BLSTNEW" msgid="">Bachelors in science Lab Tech. (New Students)</item>
-  <item key="BESNEW" msgid="">Bachelors in Envr. Science (New Students)</item>
-  <item key="BIPNEW" msgid="">Bachelors in Physics (New Students)</item>
-  <item key="BPHNEW" msgid="">Bachelors in Philosophy(New Students)</item>  
-  <item key="BSCSNEW" msgid="">Bachelors in Statistics with Com (New Students)p</item>
-  <item key="BEELNEW" msgid="">Bachelors in Elect and Elect Eng (New Students)</item>
-  <item key="BECVNEW" msgid="">Bachelors in Civil Eng. (New Students)</item>
-  <item key="BECENEW" msgid="">Bachelors in Chemical Eng. (New Students)</item>
-  <item key="BEMENEW" msgid="">Bachelors in Mechanical Eng. (New Students)</item>
-  <item key="BEPENEW" msgid="">Bachelors in Petroleum Eng. (New Students)</item>
-  <item key="BESTRNEW" msgid="">Bachelors in Structural Eng. (New Students)</item>
-  <item key="BPRENEW" msgid="">Bachelors in Production Eng. (New Students)</item>
-  <item key="BECONEW" msgid="">Bachelors in Computer Eng. (New Students)</item>
-  <item key="BADTSWNEW" msgid="">Bachelors in Adult Education (Sandwich) (New Students)</item>
-  <item key="BISCSWNEW" msgid="">Bachelors in Integrated Sci. Education (Sandwich) (New Students)</item>
-  <item key="BHEDSWNEW" msgid="">Bachelors in Health Education (Sandwich) (New Students)</item>
-  <item key="BSSTSWNEW" msgid="">Bachelors in Social studies Education (Sandwich)(New Students)</item>
-  <item key="BBEDSWNEW" msgid="">Bachelors in Business Education (Sandwich) (New Students)</item>
-  <item key="BHECSWNEW" msgid="">Bachelors in Home Economics Education (Sandwich) (New Students)</item>
-  <item key="BEMGTSWNEW" msgid="">Bachelors in Educational Management (Sandwich (New Students))</item>
-  <item key="BENLSWNEW" msgid="">Bachelors in English and Literature Education (Sandwich) (New Students)</item>
-  <item key="BCSCSWNEW" msgid="">Bachelors in Computer Science Education (Sandwich) (New Students)</item>
-  <item key="BCHESWNEW" msgid="">Bachelors in Chemistry Education (Sandwich (New Students))</item>
-  <item key="BAGRSWNEW" msgid="">Bachelors in Agriculture (Sandwich) (New Students)</item>
-  <item key="BBIOSWNEW" msgid="">Bachelors in Biology Education (Sandwich) (New Students)</item>
-  <item key="BITESWNEW" msgid="">Bachelors in Industrial Tech. Education (Sandwich) (New Students)</item>
-  <item key="BGEOSWNEW" msgid="">Bachelors in Geography Education (Sandwich) (New Students) (New Students)</item>
-  <item key="BPOLSWNEW" msgid="">Bachelors in Political Sci. Education (Sandwich) (New Students)</item>
-  <item key="BHISSWNEW" msgid="">Bachelors in History Education (Sandwich) (New Students)</item>
-  <item key="BECOSWNEW" msgid="">Bachelors in Economics Education (Sandwich) (New Students)</item>
+  <item key="BPANEW" msgid="">Bachelor in Public Adm (New Students)</item>
+  <item key="BIANEW" msgid="">Bachelor in Accounting (New Students)</item>
+  <item key="BSWNEW" msgid="">Bachelor in Social Wks (New Students)</item>
+  <item key="BFANEW" msgid="">Bachelor in Fine Arts (New Students)</item>
+  <item key="BTANEW" msgid="">Bachelor in Theatre Arts (New Students)</item>
+  <item key="BELNEW" msgid="">Bachelor in English and Literature (New Students)</item>
+  <item key="BISDNEW" msgid="">Bachelor in Int. Studies and Diplomacy (New Students)</item>
+  <item key="BFRNEW" msgid="">Bachelor in French (New Students)</item>
+  <item key="BIHNEW" msgid="">Bachelor in History (New Students)</item>
+  <item key="BILNEW" msgid="">Bachelor in Linguistics (New Students)</item>
+  <item key="BAENEW" msgid="">Bachelor in Agric Economics (New Students)</item>
+  <item key="BANNEW" msgid="">Bachelor in Animal Science (New Students)</item>
+  <item key="BACNEW" msgid="">Bachelor in Crop Science (New Students)</item>
+  <item key="BIFNEW" msgid="">Bachelor in Fisheries (New Students)</item>
+  <item key="BFWNEW" msgid="">Bachelor in Forestry and Wildlife (New Students)</item>
+  <item key="BASNEW" msgid="">Bachelor in Soil Science (New Students)</item>
+  <item key="BEMCHNEW" msgid="">Bachelor in Mechanical Eng. (New Students)</item>
+  <item key="BBFNEW" msgid="">Bachelor in Banking and Finance (New Students)</item>
+  <item key="BLGNEW" msgid="">Bachelor in Local Govt Admin (New Students)</item>
+  <item key="BLSTNEW" msgid="">Bachelor in science Lab Tech. (New Students)</item>
+  <item key="BESNEW" msgid="">Bachelor in Envr. Science (New Students)</item>
+  <item key="BIPNEW" msgid="">Bachelor in Physics (New Students)</item>
+  <item key="BPHNEW" msgid="">Bachelor in Philosophy(New Students)</item>  
+  <item key="BSCSNEW" msgid="">Bachelor in Statistics with Com (New Students)p</item>
+  <item key="BEELNEW" msgid="">Bachelor in Elect and Elect Eng (New Students)</item>
+  <item key="BECVNEW" msgid="">Bachelor in Civil Eng. (New Students)</item>
+  <item key="BECENEW" msgid="">Bachelor in Chemical Eng. (New Students)</item>
+  <item key="BEMENEW" msgid="">Bachelor in Mechanical Eng. (New Students)</item>
+  <item key="BEPENEW" msgid="">Bachelor in Petroleum Eng. (New Students)</item>
+  <item key="BESTRNEW" msgid="">Bachelor in Structural Eng. (New Students)</item>
+  <item key="BPRENEW" msgid="">Bachelor in Production Eng. (New Students)</item>
+  <item key="BECONEW" msgid="">Bachelor in Computer Eng. (New Students)</item>
+  <item key="BADTSWNEW" msgid="">Bachelor in Adult Education (Sandwich) (New Students)</item>
+  <item key="BISCSWNEW" msgid="">Bachelor in Integrated Sci. Education (Sandwich) (New Students)</item>
+  <item key="BHEDSWNEW" msgid="">Bachelor in Health Education (Sandwich) (New Students)</item>
+  <item key="BSSTSWNEW" msgid="">Bachelor in Social studies Education (Sandwich)(New Students)</item>
+  <item key="BBEDSWNEW" msgid="">Bachelor in Business Education (Sandwich) (New Students)</item>
+  <item key="BHECSWNEW" msgid="">Bachelor in Home Economics Education (Sandwich) (New Students)</item>
+  <item key="BEMGTSWNEW" msgid="">Bachelor in Educational Management (Sandwich (New Students))</item>
+  <item key="BENLSWNEW" msgid="">Bachelor in English and Literature Education (Sandwich) (New Students)</item>
+  <item key="BCSCSWNEW" msgid="">Bachelor in Computer Science Education (Sandwich) (New Students)</item>
+  <item key="BCHESWNEW" msgid="">Bachelor in Chemistry Education (Sandwich (New Students))</item>
+  <item key="BAGRSWNEW" msgid="">Bachelor in Agriculture (Sandwich) (New Students)</item>
+  <item key="BBIOSWNEW" msgid="">Bachelor in Biology Education (Sandwich) (New Students)</item>
+  <item key="BITESWNEW" msgid="">Bachelor in Industrial Tech. Education (Sandwich) (New Students)</item>
+  <item key="BGEOSWNEW" msgid="">Bachelor in Geography Education (Sandwich) (New Students) (New Students)</item>
+  <item key="BPOLSWNEW" msgid="">Bachelor in Political Sci. Education (Sandwich) (New Students)</item>
+  <item key="BHISSWNEW" msgid="">Bachelor in History Education (Sandwich) (New Students)</item>
+  <item key="BECOSWNEW" msgid="">Bachelor in Economics Education (Sandwich) (New Students)</item>
   <item key="BMTHSWNEW" msgid="">Bachelor in Maths Eduction (Sandwich) (New Students)</item>
-  <item key="LLBPTNEW" msgid="">Bachelors in Law (New Students)</item>
+  <item key="LLBPTNEW" msgid="">Bachelor in Law (New Students)</item>
   <item key="ODPTNEW" msgid="">Doctor of Optometry (New Students)</item>
   <item key="PHARMDNEW" msgid="">Doctor of Pharmacy (New Students)</item>