Index: /WAeUP_SRP/trunk/profiles/fceokene/layouts/student_personal.xml
===================================================================
--- /WAeUP_SRP/trunk/profiles/fceokene/layouts/student_personal.xml	(revision 5065)
+++ /WAeUP_SRP/trunk/profiles/fceokene/layouts/student_personal.xml	(revision 5066)
@@ -45,77 +45,77 @@
  </widget>
  <widget name="firstname" meta_type="String Widget">
+  <property name="title">Surname</property>
+  <property name="fields">
+   <element value="firstname"/>
+  </property>
+  <property name="label">Surname</property>
+  <property name="label_edit">Surname</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="for_lga" meta_type="String Widget">
+  <property name="title">Foreign Student Local Government Area</property>
+  <property name="fields">
+   <element value="for_lga"/>
+  </property>
+  <property name="label">Foreign Student Local Government Area</property>
+  <property name="label_edit">Foreign Student Local Government Area</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="for_state" meta_type="Select Widget">
+  <property name="title">Foreign Student State</property>
+  <property name="fields">
+   <element value="for_state"/>
+  </property>
+  <property name="label">Foreign Student State</property>
+  <property name="label_edit">Foreign Student State</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+  <property name="vocabulary">states</property>
+ </widget>
+ <widget name="former_surname" meta_type="String Widget">
+  <property name="title">Former Surname</property>
+  <property name="fields">
+   <element value="former_surname"/>
+  </property>
+  <property name="label">Former Surname</property>
+  <property name="label_edit">Former Surname</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="fst_best_lang" meta_type="String Widget">
+  <property name="title">First Best Language</property>
+  <property name="fields">
+   <element value="fst_best_lang"/>
+  </property>
+  <property name="label">First Best Language</property>
+  <property name="label_edit">First Best Language</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="hall" meta_type="String Widget">
+  <property name="title">Residence Hall on Campus</property>
+  <property name="fields">
+   <element value="hall"/>
+  </property>
+  <property name="label">Residence Hall on Campus</property>
+  <property name="label_edit">Residence Hall on Campus</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="lastname" meta_type="String Widget">
   <property name="title">First Name</property>
   <property name="fields">
-   <element value="firstname"/>
+   <element value="lastname"/>
   </property>
   <property name="label">First Name</property>
   <property name="label_edit">First Name</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="for_lga" meta_type="String Widget">
-  <property name="title">Foreign Student Local Government Area</property>
-  <property name="fields">
-   <element value="for_lga"/>
-  </property>
-  <property name="label">Foreign Student Local Government Area</property>
-  <property name="label_edit">Foreign Student Local Government Area</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="for_state" meta_type="Select Widget">
-  <property name="title">Foreign Student State</property>
-  <property name="fields">
-   <element value="for_state"/>
-  </property>
-  <property name="label">Foreign Student State</property>
-  <property name="label_edit">Foreign Student State</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
-  <property name="vocabulary">states</property>
- </widget>
- <widget name="former_surname" meta_type="String Widget">
-  <property name="title">Former Surname</property>
-  <property name="fields">
-   <element value="former_surname"/>
-  </property>
-  <property name="label">Former Surname</property>
-  <property name="label_edit">Former Surname</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="fst_best_lang" meta_type="String Widget">
-  <property name="title">First Best Language</property>
-  <property name="fields">
-   <element value="fst_best_lang"/>
-  </property>
-  <property name="label">First Best Language</property>
-  <property name="label_edit">First Best Language</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="hall" meta_type="String Widget">
-  <property name="title">Residence Hall on Campus</property>
-  <property name="fields">
-   <element value="hall"/>
-  </property>
-  <property name="label">Residence Hall on Campus</property>
-  <property name="label_edit">Residence Hall on Campus</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="lastname" meta_type="String Widget">
-  <property name="title">Surname / Full Name</property>
-  <property name="fields">
-   <element value="lastname"/>
-  </property>
-  <property name="label">Surname / Full Name</property>
-  <property name="label_edit">Surname / Full Name</property>
   <property name="readonly_layout_modes"/>
   <property name="hidden_layout_modes"/>
Index: /WAeUP_SRP/trunk/profiles/fceokene/layouts/student_personal_fe.xml
===================================================================
--- /WAeUP_SRP/trunk/profiles/fceokene/layouts/student_personal_fe.xml	(revision 5065)
+++ /WAeUP_SRP/trunk/profiles/fceokene/layouts/student_personal_fe.xml	(revision 5066)
@@ -45,7 +45,76 @@
  </widget>
  <widget name="firstname" meta_type="String Widget">
+  <property name="title">Surname</property>
+  <property name="fields">
+   <element value="firstname"/>
+  </property>
+  <property name="label">Surname</property>
+  <property name="label_edit">Surname</property>
+  <property name="readonly_layout_modes">
+   <element value="edit"/>
+  </property>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="for_lga" meta_type="String Widget">
+  <property name="title">Foreign Student Local Government Area</property>
+  <property name="fields">
+   <element value="for_lga"/>
+  </property>
+  <property name="label">Foreign Student Local Government Area</property>
+  <property name="label_edit">Foreign Student Local Government Area</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="for_state" meta_type="Select Widget">
+  <property name="title">Foreign Student State</property>
+  <property name="fields">
+   <element value="for_state"/>
+  </property>
+  <property name="label">Foreign Student State</property>
+  <property name="label_edit">Foreign Student State</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+  <property name="vocabulary">states</property>
+ </widget>
+ <widget name="former_surname" meta_type="String Widget">
+  <property name="title">Former Surname</property>
+  <property name="fields">
+   <element value="former_surname"/>
+  </property>
+  <property name="label">Former Surname</property>
+  <property name="label_edit">Former Surname</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="fst_best_lang" meta_type="String Widget">
+  <property name="title">First Best Language</property>
+  <property name="fields">
+   <element value="fst_best_lang"/>
+  </property>
+  <property name="label">First Best Language</property>
+  <property name="label_edit">First Best Language</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="hall" meta_type="String Widget">
+  <property name="title">Residence Hall on Campus</property>
+  <property name="fields">
+   <element value="hall"/>
+  </property>
+  <property name="label">Residence Hall on Campus</property>
+  <property name="label_edit">Residence Hall on Campus</property>
+  <property name="readonly_layout_modes"/>
+  <property name="hidden_layout_modes"/>
+  <property name="hidden_readonly_layout_modes"/>
+ </widget>
+ <widget name="lastname" meta_type="String Widget">
   <property name="title">First Name</property>
   <property name="fields">
-   <element value="firstname"/>
+   <element value="lastname"/>
   </property>
   <property name="label">First Name</property>
@@ -57,73 +126,4 @@
   <property name="hidden_readonly_layout_modes"/>
  </widget>
- <widget name="for_lga" meta_type="String Widget">
-  <property name="title">Foreign Student Local Government Area</property>
-  <property name="fields">
-   <element value="for_lga"/>
-  </property>
-  <property name="label">Foreign Student Local Government Area</property>
-  <property name="label_edit">Foreign Student Local Government Area</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="for_state" meta_type="Select Widget">
-  <property name="title">Foreign Student State</property>
-  <property name="fields">
-   <element value="for_state"/>
-  </property>
-  <property name="label">Foreign Student State</property>
-  <property name="label_edit">Foreign Student State</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
-  <property name="vocabulary">states</property>
- </widget>
- <widget name="former_surname" meta_type="String Widget">
-  <property name="title">Former Surname</property>
-  <property name="fields">
-   <element value="former_surname"/>
-  </property>
-  <property name="label">Former Surname</property>
-  <property name="label_edit">Former Surname</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="fst_best_lang" meta_type="String Widget">
-  <property name="title">First Best Language</property>
-  <property name="fields">
-   <element value="fst_best_lang"/>
-  </property>
-  <property name="label">First Best Language</property>
-  <property name="label_edit">First Best Language</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="hall" meta_type="String Widget">
-  <property name="title">Residence Hall on Campus</property>
-  <property name="fields">
-   <element value="hall"/>
-  </property>
-  <property name="label">Residence Hall on Campus</property>
-  <property name="label_edit">Residence Hall on Campus</property>
-  <property name="readonly_layout_modes"/>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
- <widget name="lastname" meta_type="String Widget">
-  <property name="title">Surname / Full Name</property>
-  <property name="fields">
-   <element value="lastname"/>
-  </property>
-  <property name="label">Surname / Full Name</property>
-  <property name="label_edit">Surname / Full Name</property>
-  <property name="readonly_layout_modes">
-   <element value="edit"/>
-  </property>
-  <property name="hidden_layout_modes"/>
-  <property name="hidden_readonly_layout_modes"/>
- </widget>
  <widget name="marit_stat" meta_type="Boolean Widget">
   <property name="title">Marital Status</property>