Index: /WAeUP_SRP/trunk/skins/waeup_layout/layout_clearance_view_slip.pt
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_layout/layout_clearance_view_slip.pt	(revision 5133)
+++ /WAeUP_SRP/trunk/skins/waeup_layout/layout_clearance_view_slip.pt	(revision 5133)
@@ -0,0 +1,97 @@
+<!-- a layout_lib macro -->
+<!-- $Id: layout_clearance_view.pt 1982 2007-07-03 16:59:12Z henrik $ -->
+<metal:block define-macro="default_view"
+  tal:define="layout options/layout;
+              widgets python:context.getRenderedWidgets(layout);
+              fields_not_displayed python:('',)"
+                                 >
+
+
+
+<span tal:omit-tag=""  tal:repeat="row layout/rows">
+<span  tal:omit-tag="" tal:repeat="cell row">
+
+<span tal:condition="python:cell['widget_id'] == 'scd_sit_fname'" style="page-break-after:always">
+ <span tal:condition="not:context/isStudent">   
+      
+      <br /><br /><br /><br />
+      <table  width=100%>
+      <tr >
+      <td width=50%></td>
+      <td width=50% style="border-top-style:solid; border-top-width:1px; border-top-color:black">Clearance Officer</td>
+      </tr>
+      </table>
+      <br /><br />
+ </span>   
+</span>                                 
+
+  <table>
+          <span tal:omit-tag="" tal:condition="python:cell['widget_rendered'] 
+                               and not cell['widget_rendered'] in ('None','-',)
+                               or cell['widget_id'] == 'birth_certificate'">
+          <span tal:omit-tag=""  tal:define="widget cell/widget"
+                tal:condition="python:cell['widget_id'] not in fields_not_displayed">
+            <div tal:omit-tag=""
+                 tal:attributes="class cell/widget_css_class|nothing;">
+                 
+            <tr tal:condition="widget/description|nothing" class="even ajaxtd">
+              <th colspan="5" align="left"><span tal:replace="widget/description" /></th>
+            </tr>
+            <tr>                         
+            <tal:block condition="widget/label">
+            <td width="180px" valign="top">
+              <span i18n:translate="" tal:condition="widget/is_i18n">
+                  <span tal:content="widget/label" />:</span>
+              <span tal:condition="not:widget/is_i18n">
+                  <span tal:content="widget/label" />:</span>
+            </td>
+            </tal:block>
+            <tal:block condition="not: widget/label">
+            <td valign="top">
+              <div> no label </div>
+            </td>
+            </tal:block>              
+            <td valign="bottom">
+             <div class="ddescription" tal:condition="cell/widget_rendered" tal:content="structure cell/widget_rendered"></div>
+             <div class="ddescription" tal:condition="not:cell/widget_rendered"> none </div>
+              </td>
+            </tr>
+            </div>
+          </span>
+          </span>
+
+    </table>  
+</span>
+</span>
+
+  <table>
+    <span  tal:define="co_id context/clearance_officer|nothing;"
+           tal:condition="co_id">
+        <tr tal:define="co_member python:context.waeup_tool.getOfficerName(co_id);">
+          <td width="180px" >Cleared By:</td>
+          <td><span tal:content="co_member" /></td>
+        </tr>
+    </span>
+ 
+  </table>
+  
+  
+ <span tal:condition="not:context/isStudent">   
+      <br /><br />
+      <table  width=100%>
+      <tr >
+      <td width=50%>Date:</td><td>Date:</td>
+      </tr>
+      </table>
+      
+      <br /><br /><br /><br />
+      <table  width=100%>
+      <tr >
+      <td width=50% style="border-top-style:solid; border-top-width:1px; border-top-color:black">Student</td>
+      <td width=50% style="border-top-style:solid; border-top-width:1px; border-top-color:black">Clearance Officer</td>
+      </tr>
+      </table>
+ </span>      
+  
+  
+</metal:block>
Index: /WAeUP_SRP/trunk/skins/waeup_student/clearance_slip.pt
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/clearance_slip.pt	(revision 5132)
+++ /WAeUP_SRP/trunk/skins/waeup_student/clearance_slip.pt	(revision 5133)
@@ -11,5 +11,4 @@
             
         <h3><span tal:content="titles/StudentClearance" /> Slip</h3>
-        <br />
         <span tal:omit-tag=""
               tal:content="structure python: info['app_doc'].render(proxy=info['app_doc'],
@@ -43,26 +42,10 @@
             </tr>
         </table>                 
-              
         <span tal:omit-tag=""
               tal:content="structure python: info['clear_doc'].render(proxy=info['clear_doc'],
-              layout_mode='view', 
+              layout_mode='view_slip', 
               layout_id='student_clearance_fe')" 
               />
-        <span tal:condition="not:context/isStudent">   
-              <br /><br />
-              <table  width=100%>
-              <tr >
-              <td width=50%>Date:</td><td>Date:</td>
-              </tr>
-              </table>
-              
-              <br /><br /><br /><br />
-              <table  width=100%>
-              <tr >
-              <td width=50% style="border-top-style:solid; border-top-width:1px; border-top-color:black"> Student</td>
-              <td width=50% style="border-top-style:solid; border-top-width:1px; border-top-color:black">Clearance Officer</td>
-              </tr>
-              </table>
-         </span>              
+           
               
       </span>
Index: /WAeUP_SRP/trunk/skins/waeup_student/getClearanceInfo.py
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_student/getClearanceInfo.py	(revision 5132)
+++ /WAeUP_SRP/trunk/skins/waeup_student/getClearanceInfo.py	(revision 5133)
@@ -19,5 +19,7 @@
 import logging
 logger = logging.getLogger('Skins.getClearanceInfo')
-from DateTime import DateTime
+import DateTime
+now = DateTime.DateTime()
+
 
 request = context.REQUEST
@@ -28,19 +30,9 @@
 path_info = request.get('PATH_INFO').split('/')
 
-# if mtool.isAnonymousUser():
-#     return None
-# info = {}
-# #from Products.zdb import set_trace
-# #set_trace()
-# requested_id = context.getStudentId()
-# if requested_id and not context.isStaff() and member_id != requested_id:
-#     logger.info('%s tried to access %s' % (member_id,requested_id))
-#     return None
-# elif context.isStaff():
-#     student_id = requested_id
-# else:
-#     student_id = member_id
 
 info = context.waeup_tool.getAccessInfo(context)
+
+info['timestamp'] = "%d" % int(now.timeTime()*1000)
+
 student_id = info['student_id']
 if student_id is None:
Index: /WAeUP_SRP/trunk/skins/waeup_uniben/slip_template.pt
===================================================================
--- /WAeUP_SRP/trunk/skins/waeup_uniben/slip_template.pt	(revision 5132)
+++ /WAeUP_SRP/trunk/skins/waeup_uniben/slip_template.pt	(revision 5133)
@@ -96,5 +96,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex ">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />