Index: WAeUP_SRP/trunk/skins/waeup_aaua/slip_template.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_aaua/slip_template.pt	(revision 5136)
+++ WAeUP_SRP/trunk/skins/waeup_aaua/slip_template.pt	(revision 5137)
@@ -96,5 +96,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />
Index: WAeUP_SRP/trunk/skins/waeup_aaue/slip_template.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_aaue/slip_template.pt	(revision 5136)
+++ WAeUP_SRP/trunk/skins/waeup_aaue/slip_template.pt	(revision 5137)
@@ -91,5 +91,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />
Index: WAeUP_SRP/trunk/skins/waeup_fceokene/slip_template.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_fceokene/slip_template.pt	(revision 5136)
+++ WAeUP_SRP/trunk/skins/waeup_fceokene/slip_template.pt	(revision 5137)
@@ -96,5 +96,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />
Index: WAeUP_SRP/trunk/skins/waeup_fceoyo/slip_template.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_fceoyo/slip_template.pt	(revision 5136)
+++ WAeUP_SRP/trunk/skins/waeup_fceoyo/slip_template.pt	(revision 5137)
@@ -96,5 +96,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />
Index: WAeUP_SRP/trunk/skins/waeup_futminna/slip_template.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_futminna/slip_template.pt	(revision 5136)
+++ WAeUP_SRP/trunk/skins/waeup_futminna/slip_template.pt	(revision 5137)
@@ -96,5 +96,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />
Index: WAeUP_SRP/trunk/skins/waeup_nau/slip_template.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_nau/slip_template.pt	(revision 5136)
+++ WAeUP_SRP/trunk/skins/waeup_nau/slip_template.pt	(revision 5137)
@@ -96,5 +96,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />
Index: WAeUP_SRP/trunk/skins/waeup_unilorin/slip_template.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_unilorin/slip_template.pt	(revision 5136)
+++ WAeUP_SRP/trunk/skins/waeup_unilorin/slip_template.pt	(revision 5137)
@@ -96,5 +96,5 @@
         <td valign="top" style="width:700px">
           <div style="padding:2em; text-align: left;" 
-               class="fontColordefaultfontcolors fontShapeTitleindex shapeAreaShape">
+               class="fontColordefaultfontcolors fontShapeTitleindex">
                   <metal:block use-macro="here/generic_lib_portal_message/macros/portal_message" />
                   <metal:block define-slot="header" />