Index: WAeUP_SRP/trunk/skins/waeup_student/add_course_result.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/add_course_result.py	(revision 5162)
+++ WAeUP_SRP/trunk/skins/waeup_student/add_course_result.py	(revision 5163)
@@ -25,8 +25,4 @@
 course_cat = context.courses_catalog
 from Products.AdvancedQuery import Eq, Between, Le,In
-try:
-    aq_portal = context.portal_catalog.evalAdvancedQuery
-except:
-    aq_portal = context.portal_catalog_real.evalAdvancedQuery
 course_id = request.get('course_id')
 mtool = context.portal_membership
Index: WAeUP_SRP/trunk/skins/waeup_student/create_level.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/create_level.py	(revision 5162)
+++ WAeUP_SRP/trunk/skins/waeup_student/create_level.py	(revision 5163)
@@ -25,15 +25,4 @@
 redirect = response.redirect
 logger = logging.getLogger('Skins.create_level')
-# mtool = context.portal_membership
-# member = mtool.getAuthenticatedMember()
-# member_id = str(member)
-# requested_id = context.getStudentId()
-# #set_trace()
-# create_level =  request.form.get('create_level',None)
-# if not create_level or not requested_id or\
-#    (not context.isStaff() and member_id != requested_id):
-#     logger.info('%s tried to access %s' % (member_id,requested_id))
-#     return redirect("%s/srp_anonymous_view" % context.portal_url())
-# student_id = context.getStudentId()
 info = context.waeup_tool.getAccessInfo(context)
 student_id = info['student_id']
@@ -41,6 +30,4 @@
     return None
 
-#lt = context.portal_layouts
-#wt = context.waeup_tool
 student = context.students_catalog.getRecordByKey(student_id)
 cert_id = student.course
@@ -55,5 +42,4 @@
 
 if context.hasObject(current_level):
-    #level = getattr(context,"%s" % current_level)
     return response.redirect("%s/%s" % (context.absolute_url(),current_level))
 else:
@@ -62,5 +48,4 @@
     context.portal_workflow.doActionFor(level,'open')
     level.getContent().edit(mapping={'session': current_session})
-    #context.portal_workflow.doActionFor(level,'close_for_edit')
 level_id = level.getId()
 session_id = context.getLevelSession(level.getContent(),student_id,level_id)
@@ -71,11 +56,8 @@
 l = []
 
-#level_nr,dummy = divmod(int(current_level),100)
-# fetch session courses from the certificate
 res = context.portal_catalog(portal_type="Certificate", id = cert_id)
 if res:
     cert = res[0]
     path = cert.getPath()
-    #academics_level = 100 * level_nr
     if int(current_level) > 0:
         academics_level = 100 * (int(current_level)/100)
Index: WAeUP_SRP/trunk/skins/waeup_student/deactivate_students.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/deactivate_students.py	(revision 5162)
+++ WAeUP_SRP/trunk/skins/waeup_student/deactivate_students.py	(revision 5163)
@@ -21,5 +21,4 @@
 logger = logging.getLogger('Skins.deactivate_students')
 from Products.AdvancedQuery import Eq, Between, Le,In
-#aq_portal = context.portal_catalog_real.evalAdvancedQuery
 aq_students = context.students_catalog.evalAdvancedQuery
 students_folder = context.portal_url.getPortalObject().campus.students
Index: WAeUP_SRP/trunk/skins/waeup_student/getClearanceInfo.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/getClearanceInfo.py	(revision 5162)
+++ WAeUP_SRP/trunk/skins/waeup_student/getClearanceInfo.py	(revision 5163)
@@ -77,19 +77,3 @@
 #     info['penalty'] = info['penalty'] and\
 #                       info['clear_doc'].entry_date.greaterThan(DateTime('2006/12/30'))
-# course = getattr(student,'study_course',None)
-# if course:
-#     cert_id = course.getContent().study_course
-#     res = context.portal_catalog(portal_type = "Certificate", id = cert_id)
-#     ci = {}
-#     if len(res) > 0:
-#         info['course'] = course
-#         brain = res[0]
-#         ci['study_course'] = brain.getId
-#         ci['title'] = brain.Title
-#         pl = brain.getPath().split('/')
-#         ci['faculty'] = pl[-4]
-#         ci['department'] = pl[-3]
-#         info['course_doc'] = ci
-#     else:
-#         info['course'] = None
 return info
Index: WAeUP_SRP/trunk/skins/waeup_student/getIdCardInfo.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/getIdCardInfo.py	(revision 5162)
+++ WAeUP_SRP/trunk/skins/waeup_student/getIdCardInfo.py	(revision 5163)
@@ -58,9 +58,4 @@
     info['personal'] = personal_doc
 
-#cert_id = sbrain.course
-#res = context.portal_catalog(portal_type = "Certificate", id = cert_id)
-#if res:
-#    brain = res[0]
-#    info['sc_title'] = brain.Title
 
 info['passport_url'] = context.portal_url() + '/viewimage/' + student_id + '/passport_' + student_id + '.jpg'
Index: WAeUP_SRP/trunk/skins/waeup_student/getStudyCourseInfo.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/getStudyCourseInfo.py	(revision 5162)
+++ WAeUP_SRP/trunk/skins/waeup_student/getStudyCourseInfo.py	(revision 5163)
@@ -52,27 +52,4 @@
 info['student'] = student_record
 cert_id = student_record.course
-# logger.info("before search")
-# starttime = DateTime.DateTime().timeTime()
-# res = context.portal_catalog_real.evalAdvancedQuery(Eq('id', cert_id)) # &
-#                                                    Eq('portal_type', "Certificate"))
-# logger.info("searchtime %f" % (DateTime.DateTime().timeTime() - starttime))
-# if True:
-#     #info['cert_id'] = cert_id
-#     # brain = res[0]
-#     # ci['title'] = brain.Title
-#     # pl = brain.getPath().split('/')
-#     # ci['faculty'] = pl[-4]
-#     # ci['department'] = pl[-3]
-#     ci['study_course'] = student_record.course
-#     ci['faculty'] = student_record.faculty
-#     ci['department'] = student_record.department
-#     info['course_doc'] = ci
-# else:
-#     info['cert_id'] = 'N/A'
-#     ci['study_course'] = 'N/A'
-#     ci['title'] = 'N/A'
-#     ci['faculty'] = 'N/A'
-#     ci['department'] = 'N/A'
-#     info['course_doc'] = ci
 ci = {}
 ci['study_course'] = student_record.course
@@ -106,6 +83,4 @@
 review_state = wftool.getInfoFor(context,'review_state',None)
 student_review_state = student_record.review_state
-#if review_state != 'content_addable' and student_review_state == 'school_fee_paid': #and context.isStudent():
-#    wftool.doActionFor(context,'close_for_edit')
 
 has_paid = student_review_state == 'school_fee_paid'
Index: WAeUP_SRP/trunk/skins/waeup_student/list_students.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/list_students.py	(revision 5162)
+++ 	(revision )
@@ -1,78 +1,0 @@
-## Script (Python) "hall_allocation_list"
-##bind container=container
-##bind context=context
-##bind namespace=
-##bind script=script
-##bind subpath=traverse_subpath
-##parameters=student=None
-##title=
-##
-# $Id$
-"""
-export student_list
-"""
-try:
-    from Products.zdb import set_trace
-except:
-    def set_trace():
-        pass
-from Products.AdvancedQuery import Eq, Between, Le,In,MatchRegexp
-try:
-    aq_portal = context.portal_catalog.evalAdvancedQuery
-except:
-    aq_portal = context.portal_catalog_real.evalAdvancedQuery
-aq_students = context.students_catalog.evalAdvancedQuery
-request = context.REQUEST
-setheader = request.RESPONSE.setHeader
-pa = context.portal_accommodation
-scat = context.students_catalog
-st_schema = context.students_catalog.schema()
-#fields = list(st_schema) + ["bed",]
-fields = ("id",
-          "name",
-          "matric_no",
-          "jamb_reg_no",
-          "sex",
-          "email",
-          "faculty",
-          "department",
-          "course",
-          "level",
-          )
-res_list = []
-lines = []
-lines.append(','.join(fields))
-format = '"%(' + ')s","%('.join(fields) + ')s"'
-#cleared = context.portal_catalog(review_state = "cleared_and_validated")
-query = In('review_state',('cleared_and_validated',
-                           'school_fee_paid',
-                           'courses_registered',
-                           'courses_validated'))
-cleared = aq_portal(query)
-newquery = Eq('portal_type','StudentApplication') & MatchRegexp('SearchableText',r'^6*')
-#newquery = MatchRegexp('SearchableText','^5*')
-#new_students = aq_portal(newquery)
-#set_trace()
-#new_sids = []
-#for ns in new_students:
-#    new_sids.append(ns.getPath().split('/')[-2])
-#set_trace()
-for student in cleared:
-##    if student.getId not in new_sids:
-##        continue
-    erg = scat(id=student.getId)
-    if not erg:
-        continue
-    if not erg[0].jamb_reg_no.startswith('6'):
-        continue
-    d = context.getFormattedStudentEntry(erg[0])
-    lines.append(format % d)
-#setheader('Content-type', 'text/x-cvs')
-#setheader('Content-type','application/vnd.ms-excel')
-setheader('Content-type','text/semicolon-seperated-values')
-setheader('Content-Disposition:', 'attachment; filename="cleared_students.csv"')
-setheader('Expires',  'Mon, 26 Jul 1997 05:00:00GMT') # Date in the past
-setheader('Cache-Control', 'no-store, no-cache,must-revalidate') # HTTP/1.1
-setheader('Cache-Control', 'post-check=0,pre-check=0')
-setheader('Pragma', 'no-cache') # HTTP/1.0
-return '\n'.join(lines)
Index: WAeUP_SRP/trunk/skins/waeup_student/payment_export.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/payment_export.py	(revision 5162)
+++ 	(revision )
@@ -1,72 +1,0 @@
-# $Id: hall_allocation_list.py 1273 2007-01-11 18:28:49Z joachim $
-"""
-export students who paid for the transfer form
-"""
-
-try:
-    from Products.zdb import set_trace
-except:
-    def set_trace():
-        pass
-
-from Products.AdvancedQuery import Eq, Between, Le,In
-request = context.REQUEST
-setheader = request.RESPONSE.setHeader
-scat = context.students_catalog
-fields = ("id",
-          "name",
-          "matric_no",
-          "jamb_reg_no",
-#          "sex",
-          "email",
-#          "phone",
-#          "faculty",
-#          "department",
-          "course",
-          "level",
-          "session",
-          "review_state",
-          "entry_session",
-          "payment_id",
-          "payment_title",
-          "indexdata",
-          )
-res_list = []
-lines = []
-lines.append(','.join(fields))
-format = '"%(' + ')s","%('.join(fields) + ')s"'
-
-portal = context.portal_catalog_real
-aq_portal = context.portal_catalog_real.evalAdvancedQuery
-payments = aq_portal(Eq('portal_type','Payment') & Eq("review_state","closed"))
-
-#payments = context.portal_catalog(portal_type='Payment')
-
-#return len(payments)
-
-for payment in payments:
-    #if not payment.id.startswith('transfer'):
-    #    continue
-    sid = payment.getPath().split('/')[-3]
-    if not sid:
-        continue
-    erg = scat(id=sid)
-    if not erg:
-        continue
-    d = context.getFormattedStudentEntry(erg[0])
-    indexdata = portal.getIndexDataForRID(payment.getRID())
-    d['payment_id'] = payment.id
-    d['payment_title'] = payment.title
-    d['indexdata'] = indexdata['SearchableText']
-    lines.append(format % d)
-
-#setheader('Content-type', 'text/x-cvs')
-#setheader('Content-type','application/vnd.ms-excel')
-setheader('Content-type','text/semicolon-seperated-values')
-setheader('Content-Disposition:', 'attachment; filename="transfer_list.csv"')
-setheader('Expires',  'Mon, 26 Jul 1997 05:00:00GMT') # Date in the past
-setheader('Cache-Control', 'no-store, no-cache,must-revalidate') # HTTP/1.1
-setheader('Cache-Control', 'post-check=0,pre-check=0')
-setheader('Pragma', 'no-cache') # HTTP/1.0
-return '\n'.join(lines)
-
Index: WAeUP_SRP/trunk/skins/waeup_student/refresh_level.py
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/refresh_level.py	(revision 5162)
+++ WAeUP_SRP/trunk/skins/waeup_student/refresh_level.py	(revision 5163)
@@ -8,6 +8,4 @@
 # $Id$
 """
-process the Application Form
-return html renderer + psm
 """
 request = context.REQUEST